module lm75a_iic_dri(
	clk,
	rst_n,
	scl,
	sda);

	//---Ports declearation: generated by Robei---
	input clk;
	input rst_n;
	output scl;
	inout sda;

	wire clk;
	wire rst_n;
	reg scl;
	wire sda;

	//----Code starts here: integrated by Robei-----
	parameter   SLAVE_ADDR =  7'b1001_010,
	                     CLK_FREQ   = 26'd33_333_000,   // i2c_driģʱƵ(CLK_FREQ) 33.33Mhz
												//CLK_FREQ   = 26'd33_3, //for test
	                     I2C_FREQ   = 20'd100_000,       // I2CSCLʱƵ 0.10Mhz ͨĶLM75A飬֪SCLС2.5us
	                     //DELAY = 29'd5_000_000,
												DELAY = 29'd5_000,//for test
	
	
	                     st_idle     = 5'b00001,          // ״̬
	                     st_sladdr   = 5'b00010,          // ַ(slave address)
	                     st_datah_rd = 5'b00100,          // 8λ
	                     st_datal_rd = 5'b01000,         // 8λ
	                     st_stop     = 5'b10000;          // I2C
	
	//reg define
	reg dri_clk;
	reg [15:0] i2c_data_r;
	reg i2c_done;
	
	reg            sda_dir     ;                     // I2C(SDA)
	reg            sda_out     ;                     // SDAź
	reg            st_done     ;                     // ״̬
	reg    [ 6:0]  cnt         ;                     // 
	reg    [ 4:0]  cur_state   ;                     // ״̬ǰ״̬
	reg    [ 4:0]  next_state  ;                     // ״̬һ״̬
	reg    [ 15:0]  data_r      ;                     // ȡ
	reg    [ 7:0]  data_wr_t   ;                     // I2CдݵʱĴ
	reg    [ 9:0]  clk_cnt     ;                     // ƵʱӼ
	
	reg    [28:0] delay;
	reg    i2c_exec;
	
	
	always@(posedge clk or negedge rst_n)begin
		if(!rst_n)begin
	        delay <= 29'd0;
			i2c_exec <= 1'b0;
	    end
	    else if(delay == DELAY)begin
			delay <= 29'd0;
			i2c_exec <= ~i2c_exec;
		end
		else
			delay <= delay + 1'b1;
	end
	
	//wire define
	wire          sda_in       ;                     // SDAź
	wire   [8:0]  clk_divide   ;                     // ģʱӵķƵϵ
	
	//
	//                   main code
	//
	
	//SDA
	assign  sda     = sda_dir ?  sda_out : 1'bz;     // SDA
	assign  sda_in  = sda ;                          // SDA
	assign  clk_divide = (CLK_FREQ/I2C_FREQ) >> 2'd3;// ģʱӵķƵϵ
	
	//I2CSCLıƵʵʱi2cĲ֤SCLߵƽмȡ͵ƽݱ仯
	always @(posedge clk or negedge rst_n) begin
	    if(rst_n == 1'b0) begin
	        dri_clk <=  1'b1;
	        clk_cnt <= 10'd0;
	    end
	    else if(clk_cnt == clk_divide - 1'd1) begin
	        clk_cnt <= 10'd0;
	        dri_clk <= ~dri_clk;
	    end
	    else
	        clk_cnt <= clk_cnt + 1'b1;
	end
	
	//(ʽ״̬)ͬʱ״̬ת
	always @(posedge dri_clk or negedge rst_n) begin
	    if(rst_n == 1'b0)
	        cur_state <= st_idle;
	    else
	        cur_state <= next_state;
	end
	
	//߼ж״̬ת
	always @( * ) begin
	//    next_state = st_idle;
	    case(cur_state)
	        st_idle: begin                            // ״̬
	           if(i2c_exec) begin
	               next_state = st_sladdr;
	           end
	           else
	               next_state = st_idle;
	        end
	        st_sladdr: begin
	            if(st_done) 
	                next_state = st_datah_rd;
	            else
	                next_state = st_sladdr ;
	        end
	        st_datah_rd: begin                        // ȡ(16bit)
	            if(st_done)
	                next_state = st_datal_rd;
	            else
	                next_state = st_datah_rd;
	        end
	        st_datal_rd:begin
	            if(st_done)
	                next_state = st_stop;
	            else
	                next_state = st_datal_rd;
	        end
	        st_stop: begin                           // I2C
	            if(st_done)
	                next_state = st_idle;
	            else
	                next_state = st_stop ;
	        end
	        default: next_state= st_idle;
	    endcase
	end
	
	//ʱ·״̬
	always @(posedge dri_clk or negedge rst_n) begin
	    //λʼ
	    if(rst_n == 1'b0) begin
	        scl        <= 1'b1;
	        sda_out    <= 1'b1;
	        sda_dir    <= 1'b1;
	        i2c_done   <= 1'b0;
	        cnt        <= 1'b0;
	        st_done    <= 1'b0;
	        data_r     <= 1'b0;
	        i2c_data_r <= 1'b0;
	    end
	    else begin
	        st_done <= 1'b0 ;
	        cnt     <= cnt +1'b1 ;
	        case(cur_state)
	             st_idle: begin                             // ״̬
	                scl     <= 1'b1;
	                sda_out <= 1'b1;
	                sda_dir <= 1'b1;
	                i2c_done<= 1'b0;
	                cnt     <= 7'b0;
	            end
	            st_sladdr: begin                            // дַ(ֵַַ)
	                case(cnt)
	                    7'd1 : sda_out <= 1'b0;             // ʼI2C
	                    7'd3 : scl <= 1'b0;
	                    7'd4 : sda_out <= SLAVE_ADDR[6];    // ַ
	                    7'd5 : scl <= 1'b1;
	                    7'd7 : scl <= 1'b0;
	                    7'd8 : sda_out <= SLAVE_ADDR[5];
	                    7'd9 : scl <= 1'b1;
	                    7'd11: scl <= 1'b0;
	                    7'd12: sda_out <= SLAVE_ADDR[4];
	                    7'd13: scl <= 1'b1;
	                    7'd15: scl <= 1'b0;
	                    7'd16: sda_out <= SLAVE_ADDR[3];
	                    7'd17: scl <= 1'b1;
	                    7'd19: scl <= 1'b0;
	                    7'd20: sda_out <= SLAVE_ADDR[2];
	                    7'd21: scl <= 1'b1;
	                    7'd23: scl <= 1'b0;
	                    7'd24: sda_out <= SLAVE_ADDR[1];
	                    7'd25: scl <= 1'b1;
	                    7'd27: scl <= 1'b0;
	                    7'd28: sda_out <= SLAVE_ADDR[0];
	                    7'd29: scl <= 1'b1;
	                    7'd31: scl <= 1'b0;
	                    7'd32: sda_out <= 1'b1;              // 1:read
	                    7'd33: scl <= 1'b1;
	                    7'd35: scl <= 1'b0;
	                    7'd36: begin
	                        sda_dir <= 1'b0;                 // ӻӦ
	                        sda_out <= 1'b1;
	                    end
	                    7'd37: scl     <= 1'b1;
	                    7'd38: st_done <= 1'b1;
	                    7'd39: begin
	                        scl <= 1'b0;
	                        cnt <= 1'b0;
	                    end
	                    default :  ;
	                endcase
	            end
	            st_datah_rd: begin                          // ȡ(8 bit)
	                case(cnt)
	                    7'd0: sda_dir <= 1'b0;
	                    7'd1: begin
	                        data_r[15] <= sda_in;
	                        scl       <= 1'b1;
	                    end
	                    7'd3: scl  <= 1'b0;
	                    7'd5: begin
	                        data_r[14] <= sda_in ;
	                        scl       <= 1'b1   ;
	                    end
	                    7'd7: scl  <= 1'b0;
	                    7'd9: begin
	                        data_r[13] <= sda_in;
	                        scl       <= 1'b1  ;
	                    end
	                    7'd11: scl  <= 1'b0;
	                    7'd13: begin
	                        data_r[12] <= sda_in;
	                        scl       <= 1'b1  ;
	                    end
	                    7'd15: scl  <= 1'b0;
	                    7'd17: begin
	                        data_r[11] <= sda_in;
	                        scl       <= 1'b1  ;
	                    end
	                    7'd19: scl  <= 1'b0;
	                    7'd21: begin
	                        data_r[10] <= sda_in;
	                        scl       <= 1'b1  ;
	                    end
	                    7'd23: scl  <= 1'b0;
	                    7'd25: begin
	                        data_r[9] <= sda_in;
	                        scl       <= 1'b1  ;
	                    end
	                    7'd27: scl  <= 1'b0;
	                    7'd29: begin
	                        data_r[8] <= sda_in;
	                        scl       <= 1'b1  ;
	                    end
	                    7'd31: scl  <= 1'b0;
	                    7'd32: begin
	                        sda_dir <= 1'b1;              // Ӧ
	                        sda_out <= 1'b0;
	                    end
	                    7'd33: scl     <= 1'b1;
	                    7'd34: st_done <= 1'b1;
	                    7'd35: begin
	                        scl <= 1'b0;
	                        cnt <= 1'b0;
	                        i2c_data_r[15:8] <= data_r[15:8];
	                    end
	                    default  :  ;
	                endcase
	            end
	            st_datal_rd: begin                          // ȡ(8 bit)
	                case(cnt)
	                    7'd0: sda_dir <= 1'b0;
	                    7'd1: begin
	                        data_r[7] <= sda_in;
	                        scl       <= 1'b1;
	                    end
	                    7'd3: scl  <= 1'b0;
	                    7'd5: begin
	                        data_r[6] <= sda_in ;
	                        scl       <= 1'b1   ;
	                    end
	                    7'd7: scl  <= 1'b0;
	                    7'd9: begin
	                        data_r[5] <= sda_in;
	                        scl       <= 1'b1  ;
	                    end
	                    7'd11: scl  <= 1'b0;
	                    7'd13: begin
	                        data_r[4] <= sda_in;
	                        scl       <= 1'b1  ;
	                    end
	                    7'd15: scl  <= 1'b0;
	                    7'd17: begin
	                        data_r[3] <= sda_in;
	                        scl       <= 1'b1  ;
	                    end
	                    7'd19: scl  <= 1'b0;
	                    7'd21: begin
	                        data_r[2] <= sda_in;
	                        scl       <= 1'b1  ;
	                    end
	                    7'd23: scl  <= 1'b0;
	                    7'd25: begin
	                        data_r[1] <= sda_in;
	                        scl       <= 1'b1  ;
	                    end
	                    7'd27: scl  <= 1'b0;
	                    7'd29: begin
	                        data_r[0] <= sda_in;
	                        scl       <= 1'b1  ;
	                    end
	                    7'd31: scl  <= 1'b0;
	                    7'd32: begin
	                        sda_dir <= 1'b1;              // Ӧ
	                        sda_out <= 1'b1;
	                    end
	                    7'd33: scl     <= 1'b1;
	                    7'd34: st_done <= 1'b1;
	                    7'd35: begin
	                        scl <= 1'b0;
	                        cnt <= 1'b0;
	                        i2c_data_r[7:0] <= data_r[7:0];
	                    end
	                    default  :  ;
	                endcase
	            end
	            st_stop: begin                            // I2C
	                case(cnt)
	                    7'd0: begin
	                        sda_dir <= 1'b1;              // I2C
	                        sda_out <= 1'b0;
	                    end
	                    7'd1 : scl     <= 1'b1;
	                    7'd3 : sda_out <= 1'b1;
	                    7'd15: st_done <= 1'b1;
	                    7'd16: begin
	                        cnt      <= 1'b0;
	                        i2c_done <= 1'b1;             // ϲģ鴫I2Cź
	                    end
	                    default  : ;
	                endcase
	            end
	        endcase
	    end
	end
endmodule    //lm75a_iic_dri

